/*
 * RegExpFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef REG_EXP_FROM_STRING_PARSER_H_
#define REG_EXP_FROM_STRING_PARSER_H_

#include "regexp/RegExpFeatures.h"
#include "RegExpFromStringLexer.h"

#include <set>
#include <memory>

namespace regexp {

class RegExpFromStringParser {
	static std::rvalue_ref < UnboundedRegExpElement < alphabet::Symbol > > alternation(std::istream& input);
	static std::rvalue_ref < UnboundedRegExpElement < alphabet::Symbol > > alternationCont(std::istream& input, std::rvalue_ref < UnboundedRegExpElement < alphabet::Symbol > > left);
	static std::rvalue_ref < UnboundedRegExpElement < alphabet::Symbol > > alternationContCont(std::istream& input, UnboundedRegExpAlternation < alphabet::Symbol > left);

	static std::rvalue_ref < UnboundedRegExpElement < alphabet::Symbol > > concatenation(std::istream& input);
	static std::rvalue_ref < UnboundedRegExpElement < alphabet::Symbol > > concatenationCont(std::istream& input, std::rvalue_ref < UnboundedRegExpElement < alphabet::Symbol > > left);
	static std::rvalue_ref < UnboundedRegExpElement < alphabet::Symbol > > concatenationContCont(std::istream& input, UnboundedRegExpConcatenation < alphabet::Symbol > left);

	static std::rvalue_ref < UnboundedRegExpElement < alphabet::Symbol > > factor(std::istream& input);
	static std::rvalue_ref < UnboundedRegExpElement < alphabet::Symbol > > star(std::istream& input, UnboundedRegExpElement < alphabet::Symbol > && elem);

public:
	static UnboundedRegExpStructure < alphabet::Symbol > parseUnboundedRegExpStructure(std::istream& input);
	static RegExp parseRegExp(std::istream& input);
	static RegExp parseRegExp(std::istream& input, const std::set<FEATURES>& features);
};

} /* namespace regexp */

#endif /* REG_EXP_FROM_STRING_PARSER_H_ */
