/*
 * RegExpStringApi.cpp
 *
 * Created on: Oct 12, 2016
 * Author: Jan Travnicek
 */

#include "RegExpStringApi.hpp"
#include "regexp/RegExpFromStringParser.h"
#include "regexp/RegExpToStringComposer.h"

namespace alib {

regexp::RegExp stringApi < regexp::RegExp >::parse ( std::istream & input ) {
	return regexp::RegExpFromStringParser::parseRegExp ( input );
}

void stringApi < regexp::RegExp >::compose ( std::ostream & output, const regexp::RegExp & data ) {
	return regexp::RegExpToStringComposer::compose ( output, data );
}

regexp::UnboundedRegExpStructure < alphabet::Symbol > stringApi < regexp::UnboundedRegExpStructure < alphabet::Symbol > >::parse ( std::istream & input ) {
	return regexp::RegExpFromStringParser::parseUnboundedRegExpStructure ( input );
}

void stringApi < regexp::UnboundedRegExpStructure < alphabet::Symbol > >::compose ( std::ostream & output, const regexp::UnboundedRegExpStructure < alphabet::Symbol > & data ) {
	return regexp::RegExpToStringComposer::compose ( output, data );
}

} /* namespace alib */
